質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.47%

  • Python 3.x

    6911questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

pythonでpandasをimportすると raise TypeErrorがでます

解決済

回答 2

投稿 編集

  • 評価
  • クリップ 2
  • VIEW 254

mmmsa

score 2

 前提・実現したいこと

練習もかねてpythonのpandasを使用としています。
ですが、import pandasをするとエラーが発生しました。

 発生している問題・エラーメッセージ

Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "/usr/local/lib/python3.5/dist-packages/pandas/__init__.py", line 23, in <module>
    from pandas.compat.numpy import *
  File "/usr/local/lib/python3.5/dist-packages/pandas/compat/__init__.py", line 409, in <module>
    from dateutil import parser as _date_parser
  File "/home/user/.local/lib/python3.5/site-packages/dateutil/parser/__init__.py", line 2, in <module>
    from ._parser import parse, parser, parserinfo
  File "/home/user/.local/lib/python3.5/site-packages/dateutil/parser/_parser.py", line 49, in <module>
    from .. import relativedelta
  File "/home/user/.local/lib/python3.5/site-packages/dateutil/relativedelta.py", line 118
    raise TypeError, "relativedelta only diffs datetime/date"
                   ^
SyntaxError: invalid syntax

 試したこと

コンソールにて以下のことを実行しました。

$ python
Python 3.5.2 (default, Nov 23 2017, 16:37:01)
>>> import pandas

 補足情報(FW/ツールのバージョンなど)

OSはUbuntu16.04
pythonは3.5を使用しています。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

checkベストアンサー

+3

はじめまして。

 はじめに

どういう作業を行ったか、質問事項に追加してください。
いかに書くことはあくまで推測に基づく解決策になります。

もしうまくいかない場合、最悪pandasの再インストールが 必要になります。

ご理解ください。

 余談ですが

pandasはそれ自体を実行するのに
多くのモジュール、ライブラリを必要とするソフトです。

ですので(たぶん)condaかpipでインストールされたと思うのですが、
必須のモジュール/ライブラリーをインストールされていないのかもしれません
あくまで可能性です。

本来であれば、requirement.txtあたりを入手し
conda/pip実行時にこのファイルを読み込み指定して
一度にインストールします。

 解決策

今のエラー結果からみての解決策ですが、エラーから
最新のパッケージを入れてみることと思います。

sudo pip install python-dateutil --upgrade

理由というかエラー解決のコツですが、こういったpipがらみのトラブルで

/python3.5/site-packages/dateuti

とあれば、site-packagesの下のdateutiがパッケージ名になります。
ですのでシステムや、Pythonベンダー、有志ユーザー提供の
パッケージがインストールされるフォルダです。
ここのエラーは大体が入れなおすか、最新のものにすれば直ります。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/04/27 09:46

    ごかいとうありがとうございます。

    質問事項にのせる内容が足りなく申し訳ありません。
    pandasの再インストールを行っても直らなかったので、
    python3.5の再インストールを行いましたがそれでも直りませんでした。
    python3.6のインストールを行ったところエラーが解消されたので本当に良かったです。

    python自体の入れなおし、最新は盲点でした。
    ありがとうございます!!

    キャンセル

  • 2018/04/27 11:15

    >python3.6のインストールを行ったところエラーが解消 
    良かったですね。

    そして原因もわかったみたいですね。

    キャンセル

+1

raise TypeError, "relativedelta only diffs datetime/date"
                   ^
SyntaxError: invalid syntax

これ、python2のシンタックスなので、エラーを出しています。

なぜ、python3のsite-packagesにpython2のモジュールが入ってしまったのかはわかりませんが…

pipとpip3が変な挙動をしたのかな…

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/04/27 09:47

    ご回答ありがとうございます。
    原因がわからずもやもやしていましたが、python2のモジュールでエラーが起きていたのですね!!

    原因がわかってすっきりしました!
    ありがとうございます。

    キャンセル

関連した質問

同じタグがついた質問を見る

  • Python 3.x

    6911questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。